#include <stdio.h>
#include <stdlib.h>
#include "playfair.h"
#include "bmp.h"

int main()
{
    const char *playfair_key = "Belfast";
    const char *plaintext = "HELLO WORLD";

    char *ciphertext = playfair_encrypt(playfair_key, plaintext);
    if (ciphertext != NULL)
    {
        printf("Playfair Encrypt: %s\n", ciphertext);
        char *decrypted = playfair_decrypt(playfair_key, ciphertext);
        if (decrypted != NULL)
        {
            printf("Playfair Decrypt: %s\n", decrypted);
            free(decrypted);
        }
        free(ciphertext);
    }
    else
    {
        printf("Playfair encryption failed.\n");
    }

    const char *bmp_key = "SECRET";
    const char *bmp_plaintext = "ATTACK AT DAWN";

    unsigned char *bmp_ciphertext = bmp_encrypt(bmp_key, bmp_plaintext);
    if (bmp_ciphertext != NULL)
    {
        printf("BMP Encrypt: ");
        for (size_t i = 0; i < strlen((const char *)bmp_ciphertext); i++)
        {
            printf("%02X ", bmp_ciphertext[i]);
        }
        printf("\n");

        char *bmp_decrypted = bmp_decrypt(bmp_key, bmp_ciphertext);
        if (bmp_decrypted != NULL)
        {
            printf("BMP Decrypt: %s\n", bmp_decrypted);
            free(bmp_decrypted);
        }
        free(bmp_ciphertext);
    }
    else
    {
        printf("BMP encryption failed.\n");
    }

    return 0;
}